package com.jolei.springTest1.service.impl;

import java.io.IOException;
import java.io.InputStream;

import javax.servlet.http.HttpServletRequest;

import org.springframework.core.io.ClassPathResource;
import org.springframework.stereotype.Service;

import com.jolei.springTest1.service.CalcRpxService;
import com.raqsoft.dm.Sequence;
import com.raqsoft.report.cache.ReportCache;
import com.raqsoft.report.cache.ReportEntry;
import com.raqsoft.report.model.ReportDefine;
import com.raqsoft.report.tag.HtmlTagApi;
import com.raqsoft.report.usermodel.Context;
import com.raqsoft.report.usermodel.Engine;
import com.raqsoft.report.usermodel.IReport;
import com.raqsoft.report.util.ReportUtils;
import com.raqsoft.report.util.ReportUtils2;

@Service
public class CalcRpxServiceImpl implements CalcRpxService {

	public String getRpxHtml(String rpxName,HttpServletRequest request) {
		/*
		*启动项目已经加载授权
		*/
		//计算报表，目前得从类路径下，主要是解决springboot打jar包找不到rpx文件问题。 但依然建议打war包发布，可能问题后面有说明
		Context cxt = null;
		//ClassPathResource rpxPath = new ClassPathResource("reportFiles/"+rpxName);
		String rpxHtmlStr = "";
		cxt = new Context();
		try {
			
			//报表文件在springboot工程的src/main/resources/reporFiles下
			ClassPathResource rpxPath = new ClassPathResource("reportFiles/"+rpxName);
			//读入报表文件
			ReportDefine rd = (ReportDefine) ReportUtils.read(rpxPath.getInputStream());
			request.setAttribute("rDefine", rd);
			
			//Engine engine = new Engine(rd, cxt);  //构造报表引擎
			//IReport iReport = engine.calc();  //运算报表
			//ReportUtils.exportToPDF("D:/abcd1231.pdf", iReport,true,false);
			/*
			*/
		//bean方式
		//ReportDefine rd = (ReportDefine)ReportUtils.read("C:\\Users\\admin\\Desktop\\springTest1\\src\\main\\resources\\reportFiles\\test.rpx");
		//ReportDefine rd = (ReportDefine) ReportUtils.read(rpxPath.getInputStream());
		
		//返回报表计算生成的html串儿，可分页。导出打印等的js函数也都生成在页面了，可以调用js函数。 如果是跨系统调（如iframe嵌入），涉及到js跨域，自行解决即可。
		HtmlTagApi api = new HtmlTagApi();
		//bean方式，必须设定srcType，file方式可省略可指定。另外，bean方式下 beanName要随时生成。
		api.setBeanName("rDefine");
		api.setSrcType("defineBean");
		//file方式
		//api.setSrcType("file");
		//api.setReportFileName(rpxName);
		//api.setName("report1");
		//api.setParams(params);
		api.setGenerateWaterMark("Hyl test!!!");
		api.setNeedSaveAsExcel("yes");
		rpxHtmlStr = api.getTagOutput(request,request.getServletContext());
		} catch (Throwable e) {
			e.printStackTrace();
		}
		return rpxHtmlStr;		
	}

	@Override
	/*
	 * 自己引入授权等可以用此方法。
	 * */
	public String getRpxTagHtml(String rpxName, HttpServletRequest request) {
		
		//增加计算报表rpx的业务逻辑,要增加不为空的判断
		//读入报表、集算器授权
		ClassPathResource reportPath = new ClassPathResource("reportLic/润乾报表技术支持内部专用授权20201231.xml");
		ClassPathResource esProcPath = new ClassPathResource("reportLic/集算器技术支持内部专用授权20201231.xml");
		try {
			InputStream reportInputStream =reportPath.getInputStream();
			InputStream esProcInputStream =esProcPath.getInputStream();
			Sequence.readLicense((byte)3, reportInputStream);
			Sequence.readLicense((byte)1, esProcInputStream);
		} catch (Exception e) {
			e.printStackTrace();
		}
		//计算报表
		IReport iReport = null;
		String cacheId = null;
		ClassPathResource rpxPath = new ClassPathResource("reportFiles/"+rpxName);
		InputStream is = null;
		try {
			is = rpxPath.getInputStream();
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		Context cxt = new Context();
		try {
			ReportEntry entry = ReportUtils2.getReportEntry(rpxName, "defineBean", request, cxt);
			IReport define = entry.getReportDefine();
			ReportUtils2.putParamMacro2Context(define, "", cxt, request, false);
			ReportCache cache = entry.getReportCache(cxt, 0);
			cacheId = cache.getId();
			iReport = cache.getReport();
			ReportUtils.exportToDOCX("D:/pdf/rpxSpringCache.docx", iReport);
		} catch (Exception e) {
			e.printStackTrace();
		} catch (Throwable e) {
			e.printStackTrace();
		}

		return null;
	}
}